/**
 * refer to http://gruntjs.com/getting-started
 */
module.exports = function(grunt)
{
	// Do grunt-related things in here

	// Project configuration.
	grunt.initConfig({
		pkg : grunt.file.readJSON('package.json'),
		gitcheck : {
			options : {
				branchChecking : true,
				enforceUncommittedChanges : true,
				enforceUpdates : true
			},
			production : {
				branches : [ 'master' ]
			}
		},
		release : {
			options : {

				npm : false, // default: true
				npmtag : false, // default: no tag

			// github : {
			// apiRoot : 'https://mas@srvgit.cag.combase.de:2000/', // Default:
			// https://github.com
			// repo :
			// 'http://mas@srvgit.cag.combase.de:8080/korona/pos/marketingsurvey2',
			// // put your user/repo here
			// usernameVar : 'mas', // ENVIRONMENT VARIABLE that contains GitHub
			// username
			// passwordVar : '' // ENVIRONMENT VARIABLE that contains GitHub
			// password
			// }
			}
		},
		// make a zipfile
		compress : {
			main : {
				options : {
					archive : 'dist/<%= pkg.name %>.zip',
					pretty : true
				},
				files : [ {
					src : "lib/**"
				}, {
					src : "node_modules/**"
				}, {
					src : "public/configuration/**"
				}, {
					src : "public/fonts/**"
				}, {
					src : "public/scripts/**"
				}, {
					src : "public/stylesheets/**"
				}, {
					src : "routes/**"
				}, {
					src : "views/**"
				}, {
					src : "app.js"
				}, {
					src : "Gruntfile.js"
				}, {
					src : "package.json"
				}, {
					src : "README.md"
				} ]
			}
		}
	});

	// refer to https://github.com/geddski/grunt-release
	grunt.loadNpmTasks('grunt-release');

	// refer to https://github.com/gruntjs/grunt-contrib-compress
	grunt.loadNpmTasks('grunt-contrib-compress');

	// refer to https://www.npmjs.com/package/grunt-gitcheck
	grunt.loadNpmTasks('grunt-gitcheck');

	// Default task(s).
	grunt.registerTask('default', [ 'release', 'compress' ]);
	
	// minor task(s).
	grunt.registerTask('minor', [ 'release:minor', 'compress' ]);

	// major task(s).
	grunt.registerTask('major', [ 'release:major', 'compress' ]);

	// Default task(s).
	grunt.registerTask('default', function()
	{
		var tasks = [ 'release', 'compress' ];

		grunt.task.run(tasks);
	});
};
